
class 'Pos'

function Pos:__init(sequence_index, line_index)
  self._line_index = line_index
  self._sequence_index = sequence_index
end

Pos.line_index = property(
  function(obj) return obj._line_index end,
  function(obj, val)
    obj._line_index = val
  end)

Pos.sequence_index = property(
  function(obj) return obj._sequence_index end,
  function(obj, val)
    obj._sequence_index = val
  end)

Pos.global_line_index = property(
  function(obj)
    local line = rns.selected_line_index
    for seq_index = 1, rns.selected_sequence_index - 1 do
      line = line + rns:pattern(rns.sequencer.pattern_sequence[seq_index]).number_of_lines
    end
    return line
  end,
  function(obj, val)
    local lines = 0
    if not (val < 1) then
      for seq_index, pat_index in ipairs(rns.sequencer.pattern_sequence) do
        lines = lines + rns:pattern(pat_index).number_of_lines
        if lines >= val then
          lines = lines - rns:pattern(pat_index).number_of_lines
          rns.selected_sequence_index = seq_index
          rns.selected_line_index = val - lines      
          return
        end
      end
    else
      obj._global_line_index = nil
    end
  end
)

function Pos:get_total_lines()
  local tot_lines = 0
  for seq_index, pat_index in ipairs(rns.sequencer.pattern_sequence) do
    tot_lines = tot_lines + rns:pattern(pat_index).number_of_lines
  end
  return tot_lines
end

