
rns = nil
dialog = nil
elements = { }
cached_songpos = nil
current_pos = nil

require 'classes'

function show_transporter()
  local vb = renoise.ViewBuilder()
  current_pos = Pos(rns.selected_sequence_index, rns.selected_line_index)
  elements = {
    ["value_minislider"] =
      vb:minislider {
        min = 1,
        max = current_pos:get_total_lines(),
        value = current_pos.global_line_index,
        height = 14,
        width = 600,
        notifier = function(val) current_pos.global_line_index = math.floor(val) end
      }
  }
  local vb_content = 
    vb:vertical_aligner {
      margin = 0,
      vb:horizontal_aligner {
        margin = 0,
        width = "100%",
        elements["value_minislider"],
      }
    }
  dialog = renoise.app():show_custom_dialog("", vb_content)
end

function main()
  rns = renoise.song()
  renoise.song().sequencer.pattern_sequence_observable:add_notifier(changed_sequence)
  renoise.song().sequencer.pattern_assignments_observable:add_notifier(changed_sequence)  
  cached_songpos = tostring(renoise.song().transport.edit_pos)
  changed_sequence()
end

function idle_check()
  if dialog and (not (tostring(renoise.song().transport.edit_pos) == tostring(cached_songpos))) then
    cached_songpos = tostring(renoise.song().transport.edit_pos)
    elements["value_minislider"].value = current_pos.global_line_index
  end
end

function changed_sequence()
  if dialog then
    elements["value_minislider"].max = current_pos:get_total_lines()
    elements["value_minislider"].value = current_pos.global_line_index
  end
end

renoise.tool():add_menu_entry({
  ["name"] = "Main Menu:Tools:Transporter",
  ["invoke"] = show_transporter
})

renoise.tool():add_keybinding {
  name = "Global:View:Show/Hide Transporter",
  invoke = function()
    if dialog and dialog.visible then
      dialog:close(); dialog = nil
    elseif dialog and (not dialog.visible) then
      show_transporter()
    else
      show_transporter()
    end
    end }

renoise.tool().app_new_document_observable:add_notifier(main)
renoise.tool().app_idle_observable:add_notifier(idle_check)

